// Generated by CoffeeScript 1.10.0
(function() {
  var React, ReactDOM, _, button, createMousetrap, div, invariant, ref, shortcuts;

  React = require('react');

  ReactDOM = require('react-dom');

  _ = require('lodash');

  invariant = require('invariant');

  createMousetrap = require('mousetrap');

  shortcuts = React.createFactory('shortcuts');

  ref = React.DOM, div = ref.div, button = ref.button;

  module.exports = React.createClass({
    displayName: 'Shortcuts',
    _mousetrap: null,
    contextTypes: {
      shortcuts: React.PropTypes.object.isRequired
    },
    propTypes: {
      handler: React.PropTypes.func.isRequired,
      name: React.PropTypes.string.isRequired,
      element: React.PropTypes.func,
      tabIndex: React.PropTypes.number,
      className: React.PropTypes.string,
      eventType: React.PropTypes.string,
      stopPropagation: React.PropTypes.bool,
      preventDefault: React.PropTypes.bool,
      targetNode: React.PropTypes.object,
      ref: React.PropTypes.string,
      nativeKeyBindingsClassName: React.PropTypes.string
    },
    getDefaultProps: function() {
      return {
        element: null,
        tabIndex: null,
        className: null,
        ref: null,
        eventType: null,
        stopPropagation: true,
        preventDefault: false,
        targetNode: null,
        nativeKeyBindingsClassName: 'native-key-bindings'
      };
    },
    _bindShortcuts: function(shortcutsArr) {
      var element;
      element = this._getElementToBind();
      element.setAttribute('tabindex', this.props.tabIndex || -1);
      this._mousetrap = createMousetrap(element);
      this._monkeyPatchMousetrap();
      return this._mousetrap.bind(shortcutsArr, this._handleShortcuts, this.props.eventType);
    },
    _monkeyPatchMousetrap: function() {
      var originalHandleKey;
      originalHandleKey = this._mousetrap._handleKey;
      this._mousetrap._handleKey = (function(_this) {
        return function(character, modifiers, e) {
          if (_this.props.preventDefault) {
            e.preventDefault();
          }
          if (_this.props.stopPropagation) {
            e.stopPropagation();
          }
          return originalHandleKey(character, modifiers, e);
        };
      })(this);
      return this._mousetrap.stopCallback = (function(_this) {
        return function(e, element) {
          var result;
          result = _.includes(element.className, _this.props.nativeKeyBindingsClassName);
          return result;
        };
      })(this);
    },
    _getElementToBind: function() {
      var element;
      if (this.props.targetNode) {
        element = this.props.targetNode;
      } else {
        element = ReactDOM.findDOMNode(this);
      }
      invariant(element, 'TargetNode was not found.');
      return element;
    },
    _unbindShortcuts: function(shortcutsArr) {
      var element, ref1;
      element = this._getElementToBind();
      element.removeAttribute('tabindex');
      return (ref1 = this._mousetrap) != null ? ref1.unbind(shortcutsArr, this.props.eventType) : void 0;
    },
    _onUpdate: function() {
      var shortcutsArr;
      shortcutsArr = this.context.shortcuts.getShortcuts(this.props.name);
      this._unbindShortcuts(shortcutsArr);
      return this._bindShortcuts(shortcutsArr);
    },
    componentDidMount: function() {
      this._onUpdate();
      return this.context.shortcuts.addUpdateListener(this._onUpdate);
    },
    componentWillUnmount: function() {
      var shortcutsArr;
      shortcutsArr = this.context.shortcuts.getShortcuts(this.props.name);
      this._unbindShortcuts(shortcutsArr);
      return this.context.shortcuts.removeUpdateListener(this._onUpdate);
    },
    _handleShortcuts: function(e, keyName) {
      var shortcutName;
      if (this.props.preventDefault) {
        e.preventDefault();
      }
      if (this.props.stopPropagation) {
        e.stopPropagation();
      }
      shortcutName = this.context.shortcuts.findShortcutName(keyName, this.props.name);
      return this.props.handler(shortcutName, e);
    },
    _onClick: function() {
      return this._unbindShortcuts(this.context.shortcuts.getShortcuts(this.props.name));
    },
    render: function() {
      var element;
      element = shortcuts;
      if (_.isFunction(this.props.element)) {
        element = this.props.element;
      }
      return element({
        tabIndex: this.props.tabIndex || -1,
        ref: this.props.ref,
        className: this.props.className
      }, this.props.children);
    }
  });

}).call(this);
